// this file is heavily modifed by RSF for the book.

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <GLUT/glut.h>
#include <signal.h>
#include <pthread.h>
#include <sys/time.h>

#include "app.h"

int exit_now; /* May be set to 1 by signal handler */
int win_id;
int ww,hh;

void signal_handler(int sig){
   exit_now = 1;
   printf("Closing\n");
   appDeinit();
   Sleep(2000); 
   exit(0);
   return;
}


static void Init(void) {
  appInit();
}

static void Draw(void){
 struct timeval timeNow;
 gettimeofday(&timeNow,NULL);
 appRender(timeNow.tv_sec*1000+timeNow.tv_usec/1000, ww,hh);
 glutSwapBuffers();
}

static void Reshape(int w, int h){
  ww=w; hh=h;
  Draw();
}

int main(int argc, char **argv){
    GLenum type;

    signal(SIGINT, signal_handler);
    signal(SIGTERM, signal_handler);
      glutInit(&argc, argv);
      type = GLUT_RGB | GLUT_DEPTH |GLUT_DOUBLE;
      glutInitDisplayMode(type);
      glutInitWindowSize(800, 600);
      win_id=glutCreateWindow("SanAngeles-OGL");
      appInit();
      glutReshapeFunc(Reshape);
      glutDisplayFunc(Draw);
      glutIdleFunc(Draw);
    glutMainLoop();

}
